#!/usr/bin/env bash
# Konfiguration
IN=~/Bilder/slide
OUT=~/Videos
PAUSE=3 # Pause zwischen den Bildern
# ohne Audio leer lassen 
#MP3=
MP3="~/Bilder/slide/audio.mp3"
# Dateinamenserweiterung der Bilddateien
ext=jpg
# Auflösung
width=1280
height=720
# Konfiguration Ende
rm build_slideshow.sh
echo ffmpeg \\ >>build_slideshow.sh
COUNTER=-1

for f in $IN/*.$ext
do
echo "Verarbeite $f"
cat<<EOF>>build_slideshow.sh
-loop 1 -t $PAUSE -i $f \\
EOF
done
# MP3
if [ -n "$MP3" ]
then
 echo -i $MP3 \\ >>build_slideshow.sh
fi
echo -filter_complex \\ >>build_slideshow.sh
echo -n \" >>build_slideshow.sh

for f in $IN/*.$ext
do
let COUNTER++
cat<<EOF>>build_slideshow.sh
[$COUNTER:v]scale=$width:$height:force_original_aspect_ratio=decrease,pad=$width:$height:(ow-iw)/2:(oh-ih)/2,setsar=1,fade=t=out:st=4:d=1[v$COUNTER]; \\
EOF
done
let COUNTER++
COUNTER2=0
while [ $COUNTER2 -lt $COUNTER ]; do
echo -n [v$COUNTER2] >>build_slideshow.sh
let COUNTER2++
done
if [ -n "$MP3" ]
then
 echo -n concat=n=$COUNTER2:v=1:a=0,format=yuv420p[v]\" -map \"[v]\" -map $COUNTER2:a -shortest $OUT/slide-output-mp3.mp4 >>build_slideshow.sh
else
 echo -n concat=n=$COUNTER2:v=1,format=yuv420p[v]\" -map \"[v]\" $OUT/slide-output.mp4 >>build_slideshow.sh
fi

chmod a+x build_slideshow.sh
exec sh build_slideshow.sh

